subroutine dera(iresp,nfac,szo,npo,n,nr,ncol,dg,pjoinc,phioc,zex,a)	
	
   integer, intent(in)::szo,npo,nr,n,ncol,nfac,dg
   integer  k,j,i,q
   double precision, intent(in)::  iresp(nr,npo),pjoinc(ncol,nr),phioc(ncol,szo,npo),zex(ncol,nfac)
   double precision, intent (inout):: a(nr,dg)
   double precision, allocatable:: enum1(:),enum2(:)
   double precision :: sum1,sum2
	   
   allocate (enum1(ncol), enum2(ncol))
 
   do l=1,nr 
	   
      ! first derivatives with respect to the thresholds
      ! the matrix a (reiser, cox) has size (szo**npo)x(npo*(nfac+szo-1)) 

	       k=1	
            do i=1,npo
	          do j=1,szo-1    
    	      
	              sum1=0
	              sum2=0 	
        	
        	
	              if (iresp(l,i).eq.j) then
	                  if ((j-1).eq.0) then
                        enum1= pjoinc(:,l)/phioc(:,j,i) 
	                  else
                        enum1= pjoinc(:,l)/(phioc(:,j,i)-phioc(:,j-1,i))	
	                  endif
	                  sum1=sum(enum1 * phioc(:,j,i) * (1-phioc(:,j,i)))
	              elseif (iresp(l,i).eq.(j+1)) then
	              enum2=pjoinc(:,l)/ (phioc(:,j+1,i)-phioc(:,j,i))
	              sum2=sum(enum2 * phioc(:,j,i) * (1-phioc(:,j,i)))
                endif
	            a(l,k)= sum1-sum2
	            k=k+1

             enddo  !j=1,szo-1
           enddo  !i=1,npo




!   first derivative for the slopes 

      if (j.eq.szo) then
		    do q=1,nfac
		     do i=1,npo
		         if ((q.gt.1).and.(i.lt.q)) then
		           k=k
		         else
		           j1=iresp(l,i)
                   if ((j1-1).eq.0) then
                    a(l,k) = (-1.0)*sum(pjoinc(:,l) *(1-phioc(:,j1,i))*zex(:,q))
                   else
                    a(l,k) = (-1.0)* sum(pjoinc(:,l) *(1-phioc(:,j1,i)-phioc(:,j1-1,i))*zex(:,q))			 
                   endif  
			       k=k+1  
			     endif         		
             enddo !i=1,npo
		    enddo ! q=1,nfac
       endif
 enddo !l=1,nr


end subroutine dera


	
					  


