##*************************************************************************
z_ext <-function(x,nfac){

## x    : punti di quadratura o pesi
## nfac : numero di fattori

nq <- length(x)                           # nr punti di quadratura
zx <- hcube(rep(nq,nfac))                 # calcola tutte le possibili disposizioni con ripetizione di 8 elementi presi a gruppi di 3
zx <- zx[,dim(zx)[2]:1]                   # zx contiene tutte le disposizioni "rovesciate"
z2 <- matrix(x[zx],dim(zx)[1],dim(zx)[2]) # in corrispondenza di ciascuna posizione vado a selezionare il nodo corrispondente. In questo modo
                                          # ottengo tutte le possibili combinazioni tra quadrature per ogni fattore latente.
return(z2)
}
##*************************************************************************
