subroutine deriv(szo,nfac,ncol,n,npo,iresp,phioc, pos,zex, di11,di22)


integer, intent(in):: n,npo,szo,nfac,ncol
integer:: n2,i,l,j,k,j1,k1

double precision, intent(in) :: phioc(ncol,szo,npo),zex(ncol,nfac),pos(ncol,n), iresp(n,npo)
double precision, intent (inout):: di11((szo+nfac-1),npo),di22((szo+nfac-1),(szo+nfac-1),npo)
double precision, allocatable:: enum1(:),enum2(:),er2(:,:,:),summa(:,:),di1(:),di2(:,:)


allocate (enum1(ncol),enum2(ncol),er2(ncol,szo,npo))


er2=0.0
         

 do i=1,npo	

 	
 
       
     do  l = 1, n     
        j = idint(iresp(l,i))	   
        er2(:,j,i) = er2(:,j,i) + pos(:,l)         
	 end do 


	 n2=szo+nfac-1
	
	     
		 
     allocate(summa(ncol,szo),di1(n2),di2(n2,n2))  

			 

		 
   	 		 
         di1 = 0.0       
         di2 = 0.0
        
		 

   
   !call dblepr ("er", -1, er2(:,:,i), n*szo) ! printing from Fortran     	 		
	
!  ********    first derivatives with respect to the thresholds******************
!
							            	
         do j=1,szo-1
              if ((j-1).eq.0) then
                  enum1(:) = er2(:,j,i) / phioc(:,j,i)
                  enum2(:) = er2(:,j+1,i) / (phioc(:,j+1,i)-phioc(:,j,i))	  
                  di1(j)=sum((enum1-enum2) * phioc(:,j,i) * (1-phioc(:,j,i)))
              else	  
                  enum1(:) = er2(:,j,i) / (phioc(:,j,i) - phioc(:,j-1,i))
                  enum2(:) = er2(:,j+1,i) / (phioc(:,j+1,i)-phioc(:,j,i))
                  di1(j) =sum((enum1-enum2) * phioc(:,j,i) * (1-phioc(:,j,i)))	       	 
             endif	        
		 end do



	 
	
	  
! ********     first derivatives with respect to alpha (factor loadings and cov on the manifest) ***************
!
        if (j.eq.szo) then	   ! solo per controllare se  uscito dai thr
          do k=1,nfac        
           summa = 0.0
            do  j1=1, szo
              if ((j1-1).eq.0) then
                summa(:,j1) = er2(:,j1,i) * (1-phioc(:,j1,i))
              else
                summa(:,j1) = er2(:,j1,i) * (1-phioc(:,j1,i)-phioc(:,j1-1,i))
              endif
		    end do

           di1(j+k-1) =(-1.0)*sum(sum(summa,dim=2)* zex(:,k))



		  end do
		end if
		 
	    di11(:,i)=di1 
		 

	
!call dblepr ("di11", -1,di1, szo+nfac-1) ! printing from Fortran

!return	  	 

!**********   second derivatives with respect to thresholds (diagonal)****************

		 
	 enum1=0.0
	 enum2=0.0


	do j=1, szo-1
        if ((j-1).eq.0) then
!	  		  
           enum1 = 1.0/(phioc(:,j,i)**2) + 1.0  		   		   	 
           enum2 = (phioc(:,j+1,i)*(1-phioc(:,j+1,i)))/ &
     &            ((phioc(:,j+1,i)-phioc(:,j,i))**2) + 1.0
	    else
           enum1 = (phioc(:,j-1,i)*(1-phioc(:,j-1,i)))/	 &
     &         ((phioc(:,j,i)-phioc(:,j-1,i))**2) + 1.0
           enum2 = (phioc(:,j+1,i)*(1-phioc(:,j+1,i)))/	&
     &         ((phioc(:,j+1,i)-phioc(:,j,i))**2) + 1.0
        endif 
	
		   di2(j,j) =(-1.0) * sum((er2(:,j,i) * enum1 + er2(:,j+1,i) * enum2)*  &
	 &	   (phioc(:,j,i)*(1-phioc(:,j,i))))   		  
	
	 end do

	
	
	
!    second derivatives with respect to alpha (diagonal)

      if (j.eq.szo) then
		  do k=1,nfac  
           summa = 0.0
		     do j1=1, szo
               if ((j1-1).eq.0) then  		    
                 summa(:,j1) =er2(:,j1,i) * (phioc(:,j1,i) *  &
     &                (1-phioc(:,j1,i)))
               else
                 summa(:,j1) = er2(:,j1,i) * (phioc(:,j1,i) * &
     &           (1-phioc(:,j1,i)) + phioc(:,j1-1,i)*(1-phioc(:,j1-1,i)))
               endif             
		     end do   
		   di2(szo+k-1,szo+k-1)=(-1.0)*sum(sum(summa,dim=2)*(zex(:,k)**2))	
		  end do

		  
!      second derivative between different alpha

       	  if (nfac.gt.1) then
            summa = 0.0
            do j1=1,szo
              if ((j1-1).eq.0) then
                 summa(:,j1) = er2(:,j1,i) * (phioc(:,j1,i) *	&
     &           (1-phioc(:,j1,i)) + 1.0)
              else
                  summa(:,j1) =  er2(:,j1,i) * (phioc(:,j1,i) *	&
     &           (1-phioc(:,j1,i)) + phioc(:,j1-1,i) * &
     &           (1-phioc(:,j1-1,i)))
	          endif
            enddo
            do k=1,nfac
		     do k1=1,nfac-1
		       if((szo+k-1).ne.(szo+k1)) then
                di2(szo+k-1,szo+k1) = sum(sum(summa,dim=2)* zex(:,k)*zex(:,k1+1))
		        di2(szo+k-1,szo+k1) =(-1.0) * di2(szo+k-1,szo+k1) 
		       end if		 
		     enddo
		    enddo
        
		  endif
		
	  end if 
		
!        second derivatives between different thresholds

       do  j=1, szo-1
          do  j1=j+1, szo-1    
            if (abs(j-j1).eq.1) then
		     di2(j,j1) = sum((er2(:,j1,i) * phioc(:,j,i) * (1-phioc(:,j,i))*  &
   &         phioc(:,j1,i) * (1-phioc(:,j1,i))) /	 &
   &         ((phioc(:,j1,i) - phioc(:,j,i))**2) )         
            else
             di2(j,j1) = 0.0
		    end if	 
		  end do
		end do    

		   	 
 

		

!        second derivatives between thresholds and alpha
!
       do j=1, szo-1
		 do k=1,nfac
           di2(j,szo+k-1) = sum((er2(:,j,i) + er2(:,j+1,i) ) * zex(:,k) *	  &
&          phioc(:,j,i) * (1-phioc(:,j,i)) )
		 end do
	   end do
	   do j=1, szo+nfac-1
         do j1=1, szo+nfac-1
           di2(j1,j) = di2(j,j1)		
		 end do
	   end do
	
		 di2=-1.0*di2

   di22(:,:,i)=di2

deallocate(summa,di1,di2)

enddo

end subroutine deriv


                      
                      
                      
               
   